---
title: HTMLImageElement.crossOrigin
slug: Web/API/HTMLImageElement/crossOrigin
tags:
  - API
  - CORS
  - Cross-Origin
  - Crossorigin
  - HTML DOM
  - HTMLImageElement
  - Image
  - Property
  - Reference
  - Security
  - origin
---
<p>{{APIRef("HTML DOM")}}</p>

<p><span class="seoSummary">The {{domxref("HTMLImageElement")}} interface's <code><strong>crossOrigin</strong></code> attribute is a string which specifies the Cross-Origin Resource Sharing ({{Glossary("CORS")}}) setting to use when retrieving the image.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>htmlImageElement</em>.crossOrigin = <em>crossOriginMode</em>;
let <em>crossOriginMode</em> = <em>htmlImageElement</em>.crossOrigin;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} of a keyword specifying the CORS mode to use when fetching the image resource. If you don't specify <code>crossOrigin</code>, the image is fetched without CORS (the fetch <code>no-cors</code> mode).</p>

<p>Permitted values are:</p>

<dl>
 <dt><code>anonymous</code></dt>
 <dd>Requests by the {{HTMLElement("img")}} element have their {{domxref("Request.mode", "mode")}} set to <code>cors</code> and their {{domxref("Request.credentials", "credentials")}} mode set to <code>same-origin</code>. This means that CORS is enabled and credentials are sent <em>if</em> the image is fetched from the same origin from which the document was loaded.</dd>
 <dt><code>use-credentials</code></dt>
 <dd>Requests by the {{domxref("HTMLImageElement")}} will use the <code>cors</code> mode and the <code>include</code> credentials mode; all image requests by the element will use CORS, regardless of what domain the fetch is from.</dd>
</dl>

<p>If <code>crossOrigin</code> is an empty string (<code>""</code>), the <code>anonymous</code> mode is selected.</p>

<h2 id="Example">Example</h2>

<p>In this example, a new {{HTMLElement("img")}} element is created and added to the document, loading the image with the Anonymous state; the image will be loaded using CORS and credentials will be used for all cross-origin loads.</p>

<h3 id="JavaScript">JavaScript</h3>

<p>The code below demonstrates setting the <code>crossOrigin</code> property on an <code>&lt;img&gt;</code> element to configure CORS access for the fetch of a newly-created image.</p>

<pre class="brush: js notranslate">const imageUrl = "https://mdn.mozillademos.org/files/16797/clock-demo-400px.png";
const container = document.querySelector(".container");

function loadImage(url) {
  const image = new Image(200, 200);
  image.addEventListener("load",
    () =&gt; container.prepend(image)
  );

  image.addEventListener("error", () =&gt; {
    const errMsg = document.createElement("output");
    errMsg.value = `Error loading image at ${url}`;
    container.append(errMsg);
  });

  image.crossOrigin = "anonymous";
  image.alt = "";
  image.src = url;
}

loadImage(imageUrl);</pre>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;div class="container"&gt;
  &lt;p&gt;Here's a paragraph. It's a very interesting paragraph. You
  are captivated by this paragraph. Keep reading this paragraph.
  Okay, now you can stop reading this paragraph. Thanks for
  reading me.&lt;/p&gt;
&lt;/div&gt;</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">body {
  font: 1.125rem/1.5, Helvetica, sans-serif;
}

.container {
  display: flow-root;
  width: 37.5em;
  border: 1px solid #d2d2d2;
}

img {
  float: left;
  padding-right: 1.5em;
}

output {
  background: rgba(100, 100, 100, 0.1);
  font-family: Courier, monospace;
  width: 95%;
}</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example", 600, 260)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#dom-img-crossorigin', 'HTMLImageElement.crossOrigin')}}</td>
   <td>{{Spec2('HTML DOM')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLImageElement.crossOrigin")}}</p>
